const EXPORTED_SYMBOLS = ["showError"];

Components.utils.import("resource://multifox-modules/util.js");
Components.utils.import("resource://multifox-modules/main.js");

function showError(win, notSupportedFeature) {
  var browser = utilEx.findBrowser(win);
  if (browser === null) {
    browser = Components.classes["@mozilla.org/appshell/window-mediator;1"]
          .getService(Components.interfaces.nsIWindowMediator)
          .getMostRecentWindow("navigator:browser")
          .gBrowser
          .selectedBrowser;
  }

  var box = browser.ownerDocument.defaultView.gBrowser.getNotificationBox(browser);
  var name = "multifox-" + notSupportedFeature;
  var notification = box.getNotificationWithValue(name);
  if (notification) {
    return;
  }

  var msg = util0.getText("notification.error.label", "Multifox", notSupportedFeature);
  box.appendNotification(msg,
                         name,
                         "chrome://global/skin/icons/warning-16.png",
                         box.PRIORITY_WARNING_MEDIUM,
                         null);
}
