 EXPORTED_SYMBOLS = ["menuShowing"];

Components.utils.import("resource://multifox-modules/util.js");

function menuShowing(evt) {
  var menu = evt.target;
  switch (menu.id || menu.getAttribute("anonid")) {
    case "menu_FilePopup":
      fileMenu(menu);
      break;
    case "placesContext":
      placesMenu(menu);
      break;
    case "contentAreaContextMenu":
      contentMenu(menu);
      break;
    case "tabContextMenu":
      tabMenu(menu);
      break;
  }
}

function onPopupHidden(evt) {
  var menu = evt.originalTarget; //<popup>
  menu.removeEventListener("popuphidden", onPopupHidden, false);

  var doc = menu.ownerDocument;
  var removeMenuItem = function(id) {
    var el = doc.getElementById(id);
    if (el) {
      el.parentNode.removeChild(el);
    }
  }

  removeMenuItem("multifox-dom-link-cmd");
  removeMenuItem("multifox-dom-link-sep");
}


function fileMenu(menu) {
  var doc = menu.ownerDocument;

  var position = doc.getElementById("menu_savePage");
  var cmd = menu.insertBefore(doc.createElement("menuitem"), position);
  var sep = menu.insertBefore(doc.createElement("menuseparator"), position);
  cmd.setAttribute("id", "multifox-dom-link-cmd");
  sep.setAttribute("id", "multifox-dom-link-sep");


  cmd.addEventListener("command", function(evt) {newIdentityCommand(evt, "fileMenu");}, false);
  cmd.setAttribute("label", util0.getText("menu.file.label"));
  cmd.setAttribute("accesskey", util0.getText("menu.file.accesskey"));

  menu.addEventListener("popuphidden", onPopupHidden, false);
}

function placesMenu(menu) {
  var doc = menu.ownerDocument;

  var item = doc.getElementById("placesContext_open:newwindow");
  if (item === null || item.hidden) {
    return;
  }


  var sepLink = doc.getElementById("placesContext_openSeparator");
  var sep = menu.insertBefore(doc.createElement("menuseparator"), sepLink);
  var cmd = menu.insertBefore(doc.createElement("menuitem"), sepLink);
  cmd.setAttribute("id", "multifox-dom-link-cmd");
  sep.setAttribute("id", "multifox-dom-link-sep");


  cmd.addEventListener("command", function(evt) {newIdentityCommand(evt, "places");}, false);
  cmd.setAttribute("label", util0.getText("context.places.label"));
  cmd.setAttribute("accesskey", util0.getText("context.places.accesskey"));

  menu.addEventListener("popuphidden", onPopupHidden, false);
}


function contentMenu(menu) {
  var doc = menu.ownerDocument;
  var item = doc.getElementById("context-openlink");
  if (item === null || item.hidden) {
    return;
  }

  var sepLink = doc.getElementById("context-sep-open");

  var sep = menu.insertBefore(doc.createElement("menuseparator"), sepLink);
  var cmd = menu.insertBefore(doc.createElement("menuitem"), sepLink);
  cmd.setAttribute("id", "multifox-dom-link-cmd");
  sep.setAttribute("id", "multifox-dom-link-sep");
  cmd.setAttribute("label", util0.getText("context.link.label"));
  cmd.setAttribute("accesskey", util0.getText("context.link.accesskey"));
  cmd.addEventListener("command", function(evt) {evt, newIdentityCommand(evt, "link");}, false);

  menu.addEventListener("popuphidden", onPopupHidden, false);
}


function tabMenu(menu) {
  var doc = menu.ownerDocument;
  var item = doc.getAnonymousElementByAttribute(doc.getElementById("content"), "id", "context_openTabInWindow");
  if (item === null || item.hidden) {
    return;
  }

  var cmd = menu.insertBefore(doc.createElement("menuitem"), item.nextSibling);
  var sep = menu.insertBefore(doc.createElement("menuseparator"), item.nextSibling);
  cmd.setAttribute("id", "multifox-dom-link-cmd");
  sep.setAttribute("id", "multifox-dom-link-sep");
  cmd.setAttribute("label", util0.getText("context.tab.label"));
  cmd.setAttribute("accesskey", util0.getText("context.tab.accesskey"));
  //cmd.setAttribute("disabled", (doc.defaultView.gBrowser.mTabs.length === 1) ? "true" : "false");//item.disabled doesn't work first time
  //cmd.setAttribute("disabled", item.getAttribute("disabled"));
  cmd.addEventListener("command", function(evt) {evt, newIdentityCommand(evt, "tab");}, false);

  menu.addEventListener("popuphidden", onPopupHidden, false);
}


function newIdentityCommand(evt, cmd) {
  var win = evt.currentTarget.ownerDocument.defaultView;
  win.document.setUserData("multifox-temp-start-new-identity-flag", "new!", null);
  switch (cmd) {
    case "places":
      win.goDoCommand("placesCmd_open:window");
      break;
    case "tab":
      //win.gBrowser.replaceTabWithWindow(win.gBrowser.mContextTab);
      Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
        .getService(Components.interfaces.nsIWindowWatcher)
        .openWindow(win,
                    "chrome://browser/content/browser.xul",
                    null,
                    "chrome,dialog=no,all",
                    win.gBrowser.mContextTab);
      break;
    case "link":
      win.gContextMenu.openLink();
      break;
    case "fileMenu":
    default:
      win.OpenBrowserWindow();
      break;
  }
}
