const EXPORTED_SYMBOLS = ["onDOMContentLoaded"];
Components.utils.import("resource://multifox-modules/util.js");
/*
(function() {
  // callback runs after first window
  function openWinCallback(xulwin) {
    xulwin
      .docShell
      .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
      .getInterface(Components.interfaces.nsIDOMWindow)
      .addEventListener("DOMContentLoaded", onDomLoaded, false);

  }

  // first window
  //.removeListener(listener);
  Components.classes["@mozilla.org/appshell/window-mediator;1"]
    .getService(Components.interfaces.nsIWindowMediator)
    .addListener({
      onOpenWindow: openWinCallback,
      onWindowTitleChange: function() {},
      onCloseWindow: function() {}
    });
})();
*/

function onDOMContentLoaded(evt) {
  util0.log('win DOMContentLoaded');
  var win = evt.currentTarget;

  //if ((doc instanceof Components.interfaces.nsIDOMDocument) === false) {
  //  util0.log('win DOMContentLoaded false -- '+doc);
  //  return;
  //}


  setWindowProfile(win)
  var doc = win.document;


  // detect session restore
  doc.addEventListener("SSTabRestoring", onTabRestoring, false);

  // menus
  doc.getAnonymousElementByAttribute(doc.getElementById("content"), "anonid", "tabContextMenu")
     .addEventListener("popupshowing", onMenuPopupShowing, false);
  addMenuListener(doc, "contentAreaContextMenu");
  addMenuListener(doc, "placesContext");
  addMenuListener(doc, "menu_FilePopup");

  //
  win.removeEventListener("DOMContentLoaded", onDOMContentLoaded, false);
}

function setWindowProfile(newWin) {
  var winOpener = newWin.opener;
  if (winOpener) {
    var cmd = winOpener.document.getUserData("multifox-temp-start-new-identity-flag");
    if (cmd === "new!") {
      util0.log("nsIWindowMediator.onOpenWindow => newProfile " + cmd);
      winOpener.document.setUserData("multifox-temp-start-new-identity-flag", null, null);
      Components.utils.import("resource://multifox-modules/main.js");
      SetWindow.newId(newWin);
      return;
    }
  }

  // inherit identity profile
  if (util0.setHttpObservers.isActive) {
    Components.utils.import("resource://multifox-modules/main.js");
    SetWindow.inheritId(newWin, winOpener);
  } else {
    util0.log("nsIWindowMediator.onOpenWindow => util0.setHttpObservers.isActive=false");
  }
}


function onTabRestoring(evt) {
  var doc = evt.currentTarget;
  var win = doc.defaultView;

  // we need to [re]configure identity window id,
  // only the first restored tab is necessary.
  doc.removeEventListener("SSTabRestoring", onTabRestoring, false);

  var stringId = Components.classes["@mozilla.org/browser/sessionstore;1"]
                  .getService(Components.interfaces.nsISessionStore)
                  .getWindowValue(win, "multifox-dom-identity-id");

  if (util0.setHttpObservers.isActive === false && stringId.length === 0) {
    // default scenario
    util0.log("first tab restoring NOP ");
    return;
  }

  util0.log("first tab restoring " + stringId);

  // add icon; sync id  override any previous profile id
  Components.utils.import("resource://multifox-modules/main.js");
  SetWindow.applyRestore(win);
}


function onMenuPopupShowing(evt) {
  Components.utils.import("resource://multifox-modules/menus.js");
  menuShowing(evt);
}

function addMenuListener(doc, id) {
  doc.getElementById(id).addEventListener("popupshowing", onMenuPopupShowing, false);
}
