const EXPORTED_SYMBOLS = ["util0"];

const util0 = {
  log: function(msg) {//status stat
    var now = new Date();
    var p = "Multifox@" + now.toLocaleTimeString() + '>';
    dump('\n------------------------------------------------------------------\n' + p + msg);
    Components.classes["@mozilla.org/consoleservice;1"]
      .getService(Components.interfaces.nsIConsoleService)
      .logStringMessage(p + msg);
  },

  getText: function(msg) {
    var len = arguments.length - 1;
    var args = new Array(len);
    for (var idx = 0; idx < len; idx++) {
      args[idx] = arguments[idx + 1];
    }
    return Components.classes["@mozilla.org/intl/stringbundle;1"]
            .getService(Components.interfaces.nsIStringBundleService)
            .createBundle("chrome://multifox/locale/general.properties")
            .formatStringFromName(msg, args, args.length);
  },

  setHttpObservers: {
    _observers: null,

    get isActive() {
      return this._observers !== null;
    },

    enable: function(onRequest, onResponse) {
      if (this._observers !== null) {
        throw "connections.enable ==> this._observers=true";
      }
      this._observers = [onRequest, onResponse];

      util0.log('connections on');
      var obs = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
      obs.addObserver(this._observers[0], "http-on-modify-request", false);
      obs.addObserver(this._observers[1], "http-on-examine-response", false);


      obs.addObserver({observe: function(aSubject, aTopic, aData) {
        utilEx.dbg('cookie-rejected', aSubject, aTopic, aData, aSubject.QueryInterface(Components.interfaces.nsIURI).spec);
      }}, "cookie-rejected", false);
    },

    disable: function() {
      util0.log("connections off");
      var obs = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
      obs.removeObserver(this._observers[0], "http-on-modify-request");
      obs.removeObserver(this._observers[1], "http-on-examine-response");
      this._observers = null;
    }
  }

};
